diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index 1601225cd..093e119a8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.item.model.ItemModelStandard;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -13,10 +14,23 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.DisplayPos;
 
 import java.util.Arrays;
+import java.util.HashMap;
+import java.util.Map;
 
 public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
+    protected static final RenderBlocks renderBlocks = new RenderBlocks();
+
+    protected static final DisplayPos DEFAULT_BLOCK_GUI = new DisplayPos(0, 0, 0, 30, 225, 0, 0.625f, 0.625f, 0.625f);
+    protected static final DisplayPos DEFAULT_BLOCK_GROUND = new DisplayPos(0, 3/16f, 0, 0, 0, 0, 0.25f, 0.25f, 0.25f);
+    protected static final DisplayPos DEFAULT_BLOCK_FIXED = new DisplayPos(0, 0, 0, 0, 0, 0, 0.5f, 0.5f, 0.5f);
+    protected static final DisplayPos DEFAULT_BLOCK_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 2.5f/16f, 0, 75, 45, 0, 0.375f, 0.375f, 0.375f);
+    protected static final DisplayPos DEFAULT_BLOCK_THIRD_PERSON_LEFT_HAND = new DisplayPos(-0, 2.5f/16f, 0, 75, 45, 0, 0.375f, 0.375f, 0.375f);
+    protected static final DisplayPos DEFAULT_BLOCK_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0, 0, 0, 0, 45, 0, 0.4f, 0.4f, 0.4f);
+    protected static final DisplayPos DEFAULT_BLOCK_FIRST_PERSON_LEFT_HAND = new DisplayPos(0, 0, 0, 0, 225, 0, 0.4f, 0.4f, 0.4f);
+
     public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
     public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
     public @Nullable AABB itemRenderBounds = null;
@@ -32,19 +46,52 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
     protected final TextureLayer retroBlockTextures = new TextureLayer();
     protected final TextureLayer retroOverbrightTextures = new TextureLayer();
 
+    protected @NotNull Map<@NotNull String, @NotNull DisplayPos> displayPosMap = new HashMap<>();
+
     public BlockModelStandard(Block<T> block) {
         super(block);
+        displayPosMap.put(DisplayPos.GUI, DEFAULT_BLOCK_GUI);
+        displayPosMap.put(DisplayPos.GROUND, DEFAULT_BLOCK_GROUND);
+        displayPosMap.put(DisplayPos.FIXED, DEFAULT_BLOCK_FIXED);
+        displayPosMap.put(DisplayPos.THIRD_PERSON_RIGHT_HAND, DEFAULT_BLOCK_THIRD_PERSON_RIGHT_HAND);
+        displayPosMap.put(DisplayPos.THIRD_PERSON_LEFT_HAND, DEFAULT_BLOCK_THIRD_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
+        displayPosMap.put(DisplayPos.FIRST_PERSON_RIGHT_HAND, DEFAULT_BLOCK_FIRST_PERSON_RIGHT_HAND);
+        displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, DEFAULT_BLOCK_FIRST_PERSON_LEFT_HAND);
+    }
+
+    @Override
+    public boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        renderBlocks.renderAllFaces = true;
+        boolean result = render(tessellator, worldSource, x, y, z);
+        renderBlocks.renderAllFaces = false;
+        return result;
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        return renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
+    public boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, IconCoordinate textureIndex) {
+        renderBlocks.overrideBlockTexture = textureIndex;
+        boolean result = render(tessellator, worldSource, x, y, z);
+        renderBlocks.overrideBlockTexture = null;
+        return result;
     }
 
     @Override
-	public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        return renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+    }
+
+    @Override
+    public boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        renderBlocks.overbright = true;
+        boolean result = render(tessellator, worldSource, x, y, z);
+        renderBlocks.overbright = false;
+        return result;
+    }
+
+    @Override
+	public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
 		if(renderBlocks.useInventoryTint) {
-			int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+			int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
 			float r = (float) (color >> 16 & 0xff) / 255F;
 			float g = (float) (color >> 8 & 0xff) / 255F;
 			float b = (float) (color & 0xff) / 255F;
@@ -68,22 +115,22 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
         tessellator.startDrawingQuads();
 
         tessellator.setNormal(0.0f, -1.0f, 0.0f);
-        renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
 
         tessellator.setNormal(0.0f, 1.0f, 0.0f);
-        renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
 
         tessellator.setNormal(0.0f, 0.0f, -1.0f);
-        renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
 
         tessellator.setNormal(0.0f, 0.0f, 1.0f);
-        renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
 
         tessellator.setNormal(-1.0f, 0.0f, 0.0f);
-        renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
 
         tessellator.setNormal(1.0f, 0.0f, 0.0f);
-        renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
 
         tessellator.draw();
 
@@ -92,7 +139,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
 
             brightness = 1.0f;
             if(renderBlocks.useInventoryTint) {
-                int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+                int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
                 float r = (float) (color >> 16 & 0xff) / 255F;
                 float g = (float) (color >> 8 & 0xff) / 255F;
                 float b = (float) (color & 0xff) / 255F;
@@ -108,22 +155,22 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
             tessellator.startDrawingQuads();
 
             tessellator.setNormal(0.0f, -1.0f, 0.0f);
-            renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
+            renderBlocks.renderBottomFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
 
             tessellator.setNormal(0.0f, 1.0f, 0.0f);
-            renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.TOP, metadata));
+            renderBlocks.renderTopFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.TOP, metadata));
 
             tessellator.setNormal(0.0f, 0.0f, -1.0f);
-            renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.NORTH, metadata));
+            renderBlocks.renderNorthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.NORTH, metadata));
 
             tessellator.setNormal(0.0f, 0.0f, 1.0f);
-            renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.SOUTH, metadata));
+            renderBlocks.renderSouthFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.SOUTH, metadata));
 
             tessellator.setNormal(-1.0f, 0.0f, 0.0f);
-            renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.WEST, metadata));
+            renderBlocks.renderWestFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.WEST, metadata));
 
             tessellator.setNormal(1.0f, 0.0f, 0.0f);
-            renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
+            renderBlocks.renderEastFace(tessellator, bounds, 0.0, 0.0, 0.0, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
 
             tessellator.draw();
 
@@ -137,17 +184,23 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
     }
 
     @Override
-    public float getItemRenderScale() {
-        return 0.25f;
+    public @NotNull DisplayPos getItemDisplayPos(@NotNull String id) {
+        return displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
+    }
+
+    public @NotNull BlockModelStandard<T> setDisplayPos(@NotNull String id, @NotNull DisplayPos displayPos) {
+        this.displayPosMap.put(id, displayPos);
+        return this;
     }
-    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
+
+    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
     {
         return getBlockTextureFromSideAndMetadata(side, blockAccess.getBlockMetadata(x, y, z));
     }
-    @Override
-    public IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, int side)
+
+    public @Nullable IconCoordinate getBlockOverbrightTexture(WorldSource blockAccess, int x, int y, int z, @NotNull Side side)
     {
-        return getBlockOverbrightTextureFromSideAndMeta(Side.getSideById(side), blockAccess.getBlockMetadata(x, y, z));
+        return getBlockOverbrightTextureFromSideAndMeta(side, blockAccess.getBlockMetadata(x, y, z));
     }
 
     @Override
@@ -155,16 +208,14 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
         return overbrightTextures.hasTexture();
     }
 
-    @Override
-    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
         if (retroOverbrightTextures.hasTexture && isRetro()) {
             return retroOverbrightTextures.get(side);
         }
         return overbrightTextures.get(side);
     }
 
-    @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if (retroBlockTextures.hasTexture && isRetro()) {
             return retroBlockTextures.get(side);
@@ -172,39 +223,43 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
         return blockTextures.get(side);
     }
     @Override
-    public IconCoordinate getParticleTexture(Side side, int meta){
+    public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta){
         return getBlockTextureFromSideAndMetadata(side, meta);
     }
+
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side, int meta)
+    public @Nullable IconCoordinate getOverlayTexture(int meta) {
+        return getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
+    }
+
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side, int meta)
     {
         return shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
-    @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
-        Side side1 = Side.getSideById(side);
-        if(side1 == Side.BOTTOM && bounds.minY > 0.0D)
+        if(side == Side.BOTTOM && bounds.minY > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.TOP && bounds.maxY < 1.0D)
+        else if(side == Side.TOP && bounds.maxY < 1.0D)
         {
             return true;
         }
-        else if(side1 == Side.NORTH && bounds.minZ > 0.0D)
+        else if(side == Side.NORTH && bounds.minZ > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.SOUTH && bounds.maxZ < 1.0D)
+        else if(side == Side.SOUTH && bounds.maxZ < 1.0D)
         {
             return true;
         }
-        else if(side1 == Side.WEST && bounds.minX > 0.0D)
+        else if(side == Side.WEST && bounds.minX > 0.0D)
         {
             return true;
         }
-        else if(side1 == Side.EAST && bounds.maxX < 1.0D)
+        else if(side == Side.EAST && bounds.maxX < 1.0D)
         {
             return true;
         }
@@ -213,17 +268,22 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
             return !blockAccess.isBlockOpaqueCube(x, y, z);
         }
     }
-    @Override
-    public boolean shouldSideBeColored(WorldSource blockAccess, int x, int y, int z, int side, int meta){
+
+    public boolean shouldSideBeColored(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta){
         return true;
     }
+
     @Override
+    public int particleColorIndex(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta) {
+        return shouldSideBeColored(worldSource, x, y, z, side, meta) ? 0 : -1;
+    }
+
     public AABB getBlockBoundsForItemRender()
     {
         if (itemRenderBounds != null){
             return itemRenderBounds;
         }
-        return super.getBlockBoundsForItemRender();
+        return block.getBounds();
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
index a32e26629..1b96cab2b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStoneMossy.java
@@ -7,6 +7,8 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -18,23 +20,23 @@ public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
-        renderStandardBlock(tessellator, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
         renderBlocks.overrideBlockTexture = mossOverlay;
-        renderStandardBlock(tessellator, bounds, x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         renderBlocks.overrideBlockTexture = null;
         return true;
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         renderBlocks.useInventoryTint = false;
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         renderBlocks.useInventoryTint = true;
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
@@ -45,27 +47,27 @@ public class BlockModelStoneMossy<T extends BlockLogic> extends BlockModelStanda
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
-        renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
-        renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
-        renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
+        renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, mossCoord);
         tessellator.draw();
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index bb8fae801..b99e1643a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -7,6 +7,9 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicTorch;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelTorch(Block<T> block) {
@@ -14,12 +17,12 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
         }else {
-            brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
             if(block.emission > 0) {
                 brightness = 1.0F;
             }
@@ -28,7 +31,7 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
-        int direction = renderBlocks.blockAccess.getBlockMetadata(x, y, z) & BlockLogicTorch.MASK_DIRECTION;
+        int direction = worldSource.getBlockMetadata(x, y, z) & BlockLogicTorch.MASK_DIRECTION;
         switch (direction) {
             case BlockLogicTorch.SIDE_WEST:
                 renderTorchAtAngle(tessellator, (double) x - d1, (double) y + d2, z, -d, 0.0D);
@@ -107,8 +110,5 @@ public class BlockModelTorch<T extends BlockLogic> extends BlockModelStandard<T>
     public boolean shouldItemRender3d() {
         return false;
     }
-    @Override
-    public float getItemRenderScale() {
-        return 0.5f;
-    }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
index 0b31ef818..205245bb4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
@@ -5,16 +5,18 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelTorchRedstone<T extends BlockLogic> extends BlockModelTorch<T> {
-    private static final BlockModel<?> redstoneWire = BlockModelDispatcher.getInstance().getDispatch(Blocks.WIRE_REDSTONE);
+    private static final BlockModelStandard<?> redstoneWire = (BlockModelStandard<?>) BlockModelDispatcher.getInstance().getDispatch(Blocks.WIRE_REDSTONE);
 
     public BlockModelTorchRedstone(Block<T> block) {
         super(block);
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         if(side == Side.TOP)
         {
@@ -26,7 +28,7 @@ public class BlockModelTorchRedstone<T extends BlockLogic> extends BlockModelTor
     }
 
     @Override
-    public IconCoordinate getParticleTexture(Side side, int meta) {
+    public @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta) {
         return blockTextures.get(Side.NORTH);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
index 887066417..eff666ee2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
@@ -2,8 +2,10 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelTransparent<T extends BlockLogic> extends BlockModelStandard<T> {
     private final boolean renderInside;
@@ -12,7 +14,7 @@ public class BlockModelTransparent<T extends BlockLogic> extends BlockModelStand
         this.renderInside = renderInside;
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
     {
         if(!renderInside && blockAccess.getBlockId(x, y, z) == block.id())
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index f29b8e6a1..8096fe0a9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -8,6 +8,8 @@ import net.minecraft.core.block.BlockLogicTrapDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -19,8 +21,8 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int metadata = worldSource.getBlockMetadata(x, y, z);
         boolean isUp = BlockLogicTrapDoor.isTrapdoorOpen(metadata);
 
         if(isUp) {
@@ -62,17 +64,17 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
                 renderBlocks.uvRotateWest = 3;
             }
         }
-        super.render(tessellator, x, y, z);
-        resetRenderBlocks();
+        super.render(tessellator, worldSource, x, y, z);
+        renderBlocks.resetRenderBlocks();
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(0, 0.25f, 0);
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int orientation = data & 3;
         if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
index 0a38a0ca6..2e5c882fb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelTrapDoorPainted<T extends BlockLogic> extends BlockModelTrapDoor<T> {
     public static final IconCoordinate[] topTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
@@ -24,7 +25,7 @@ public class BlockModelTrapDoorPainted<T extends BlockLogic> extends BlockModelT
         super(block);
     }
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         int orientation = data & 3;
